/[gentoo-x86]/eclass/flag-o-matic.eclass
Gentoo

Diff of /eclass/flag-o-matic.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.54 Revision 1.124
1# Copyright 1999-2003 Gentoo Technologies, Inc. 1# Copyright 1999-2008 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.54 2004/06/06 16:39:18 solar Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.124 2008/07/03 05:30:54 dberkholz Exp $
4
5# @ECLASS: flag-o-matic.eclass
6# @MAINTAINER:
7# toolchain@gentoo.org
8# @BLURB: common functions to manipulate and query toolchain flags
9# @DESCRIPTION:
10# This eclass contains a suite of functions to help developers sanely
11# and safely manage toolchain flags in their builds.
12
13inherit eutils toolchain-funcs multilib
14
15################ DEPRECATED functions ################
16# The following are still present to avoid breaking existing
17# code more than necessary; however they are deprecated. Please
18# use gcc-specs-* from toolchain-funcs.eclass instead, if you
19# need to know which hardened techs are active in the compiler.
20# See bug #100974
4# 21#
5# Author Bart Verwilst <verwilst@gentoo.org> 22# has_hardened
23# has_pie
24# has_pic
25# has_ssp_all
26# has_ssp
6 27
7ECLASS=flag-o-matic
8INHERITED="$INHERITED $ECLASS"
9IUSE="debug"
10 28
11#
12#### filter-flags <flags> ####
13# Remove particular flags from C[XX]FLAGS
14# Matches only complete flags
15#
16#### append-flags <flags> ####
17# Add extra flags to your current C[XX]FLAGS
18#
19#### replace-flags <orig.flag> <new.flag> ###
20# Replace a flag by another one
21#
22#### replace-cpu-flags <new.cpu> <old.cpus> ###
23# Replace march/mcpu flags that specify <old.cpus>
24# with flags that specify <new.cpu>
25#
26#### is-flag <flag> ####
27# Returns "true" if flag is set in C[XX]FLAGS
28# Matches only complete a flag
29#
30#### strip-flags ####
31# Strip C[XX]FLAGS of everything except known
32# good options.
33#
34#### strip-unsupported-flags ####
35# Strip C[XX]FLAGS of any flags not supported by
36# installed version of gcc
37#
38#### get-flag <flag> ####
39# Find and echo the value for a particular flag
40#
41#### replace-sparc64-flags ####
42# Sets mcpu to v8 and uses the original value
43# as mtune if none specified.
44#
45#### filter-mfpmath <math types> ####
46# Remove specified math types from the fpmath specification
47# If the user has -mfpmath=sse,386, running `filter-mfpmath sse`
48# will leave the user with -mfpmath=386
49#
50#### append-ldflags ####
51# Add extra flags to your current LDFLAGS
52#
53#### filter-ldflags <flags> ####
54# Remove particular flags from LDFLAGS
55# Matches only complete flags
56#
57#### etexec-flags ####
58# hooked function for hardened gcc that appends
59# -fno-pic to {C,CXX,LD}FLAGS
60# when a package is filtering -fpic, -fPIC, -fpie, -fPIE
61#
62#### fstack-flags ####
63# hooked function for hardened gcc that appends
64# -fno-stack-protector to {C,CXX,LD}FLAGS
65# when a package is filtering -fstack-protector, -fstack-protector-all
66# notice: modern automatic specs files will also suppress -fstack-protector-all
67# when only -fno-stack-protector is given
68#
69
70# C[XX]FLAGS that we allow in strip-flags 29# {C,CXX,F,FC}FLAGS that we allow in strip-flags
30# Note: shell globs and character lists are allowed
71setup-allowed-flags() { 31setup-allowed-flags() {
72 if [ -z "${ALLOWED_FLAGS}" ] ; then 32 if [[ -z ${ALLOWED_FLAGS} ]] ; then
73 export ALLOWED_FLAGS="-O -O1 -O2 -mcpu -march -mtune -fstack-protector -fno-unit-at-a-time -pipe -g" 33 export ALLOWED_FLAGS="-pipe"
34 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -O -O0 -O1 -O2 -mcpu -march -mtune"
35 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fstack-protector -fstack-protector-all"
36 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fbounds-checking"
37 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-PIE -fno-pie -fno-unit-at-a-time"
38 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -g -g[0-9] -ggdb -ggdb[0-9] -gstabs -gstabs+"
39 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-ident"
40 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -W* -w"
41 fi
42 # allow a bunch of flags that negate features / control ABI
43 ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-stack-protector -fno-stack-protector-all \
44 -fno-strict-aliasing -fno-bounds-checking"
45 ALLOWED_FLAGS="${ALLOWED_FLAGS} -mregparm -mno-app-regs -mapp-regs \
46 -mno-mmx -mno-sse -mno-sse2 -mno-sse3 -mno-3dnow \
47 -mips1 -mips2 -mips3 -mips4 -mips32 -mips64 -mips16 \
48 -msoft-float -mno-soft-float -mhard-float -mno-hard-float -mfpu \
49 -mieee -mieee-with-inexact -mschedule \
50 -mtls-direct-seg-refs -mno-tls-direct-seg-refs \
51 -mflat -mno-flat -mno-faster-structs -mfaster-structs \
52 -m32 -m64 -mabi -mlittle-endian -mbig-endian -EL -EB -fPIC \
53 -mlive-g0 -mcmodel -mstack-bias -mno-stack-bias \
54 -msecure-plt -D*"
55
56 # {C,CXX,F,FC}FLAGS that we are think is ok, but needs testing
57 # NOTE: currently -Os have issues with gcc3 and K6* arch's
58 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks"
59 return 0
60}
61
62# inverted filters for hardened compiler. This is trying to unpick
63# the hardened compiler defaults.
64_filter-hardened() {
65 local f
66 for f in "$@" ; do
74 case "${ARCH}" in 67 case "${f}" in
75 mips) ALLOWED_FLAGS="${ALLOWED_FLAGS} -mips1 -mips2 -mips3 -mips4 -mabi" ;; 68 # Ideally we should only concern ourselves with PIE flags,
76 amd64) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC -m64" ;; 69 # not -fPIC or -fpic, but too many places filter -fPIC without
77 x86) ALLOWED_FLAGS="${ALLOWED_FLAGS} -m32" ;; 70 # thinking about -fPIE.
78 alpha) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC" ;; 71 -fPIC|-fpic|-fPIE|-fpie|-Wl,pie|-pie)
79 ia64) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC" ;; 72 gcc-specs-pie || continue
73 is-flagq -nopie || append-flags -nopie;;
74 -fstack-protector)
75 gcc-specs-ssp || continue
76 is-flagq -fno-stack-protector || append-flags -fno-stack-protector;;
77 -fstack-protector-all)
78 gcc-specs-ssp-to-all || continue
79 is-flagq -fno-stack-protector-all || append-flags -fno-stack-protector-all;;
80 esac 80 esac
81 fi 81 done
82
83 # C[XX]FLAGS that we are think is ok, but needs testing
84 # NOTE: currently -Os have issues with gcc3 and K6* arch's
85 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks -fprefetch-loop-arrays"
86 return 0
87} 82}
88 83
84# Remove occurrences of strings from variable given in $1
85# Strings removed are matched as globs, so for example
86# '-O*' would remove -O1, -O2 etc.
87_filter-var() {
88 local f x VAR VAL
89 declare -a new
90
91 VAR=$1
92 shift
93 eval VAL=\${${VAR}}
94 for f in ${VAL}; do
95 for x in "$@"; do
96 # Note this should work with globs like -O*
97 [[ ${f} == ${x} ]] && continue 2
98 done
99 eval new\[\${\#new\[@]}]=\${f}
100 done
101 eval export ${VAR}=\${new\[*]}
102}
103
104# @FUNCTION: filter-flags
105# @USAGE: <flags>
106# @DESCRIPTION:
107# Remove particular <flags> from {C,CPP,CXX,F,FC}FLAGS. Accepts shell globs.
89filter-flags() { 108filter-flags() {
90 for x in "$@" ; do 109 _filter-hardened "$@"
91 case "${x}" in 110 _filter-var CFLAGS "$@"
92 -fPIC|-fpic|-fPIE|-fpie|-pie) etexec-flags;; 111 _filter-var CPPFLAGS "$@"
93 -fstack-protector|-fstack-protector-all) fstack-flags;; 112 _filter-var CXXFLAGS "$@"
94 *) ;; 113 _filter-var FFLAGS "$@"
95 esac 114 _filter-var FCFLAGS "$@"
96 done
97
98 # we do this fancy spacing stuff so as to not filter
99 # out part of a flag ... we want flag atoms ! :D
100 CFLAGS=" ${CFLAGS} "
101 CXXFLAGS=" ${CXXFLAGS} "
102 for x in "$@" ; do
103 CFLAGS="${CFLAGS// ${x} / }"
104 CXXFLAGS="${CXXFLAGS// ${x} / }"
105 done
106 CFLAGS="${CFLAGS:1:${#CFLAGS}-2}"
107 CXXFLAGS="${CXXFLAGS:1:${#CXXFLAGS}-2}"
108 return 0 115 return 0
109} 116}
110 117
118# @FUNCTION: filter-lfs-flags
119# @DESCRIPTION:
120# Remove flags that enable Large File Support.
111filter-lfs-flags() { 121filter-lfs-flags() {
122 [[ -n $@ ]] && die "filter-lfs-flags takes no arguments"
112 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE 123 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
113} 124}
114 125
126# @FUNCTION: append-cppflags
127# @USAGE: <flags>
128# @DESCRIPTION:
129# Add extra <flags> to the current CPPFLAGS.
130append-cppflags() {
131 [[ -z $* ]] && return 0
132 export CPPFLAGS="${CPPFLAGS} $*"
133 return 0
134}
135
136# @FUNCTION: append-fflags
137# @USAGE: <flags>
138# @DESCRIPTION:
139# Add extra <flags> to the current {F,FC}FLAGS.
140append-fflags() {
141 [[ -z $* ]] && return 0
142 export FFLAGS="${FFLAGS} $*"
143 export FCFLAGS="${FCFLAGS} $*"
144 return 0
145}
146
147# @FUNCTION: append-lfs-flags
148# @DESCRIPTION:
149# Add flags that enable Large File Support.
115append-lfs-flags() { 150append-lfs-flags() {
151 [[ -n $@ ]] && die "append-lfs-flags takes no arguments"
116 append-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE 152 append-cppflags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
117} 153}
118 154
155# @FUNCTION: append-flags
156# @USAGE: <flags>
157# @DESCRIPTION:
158# Add extra <flags> to your current {C,CXX,F,FC}FLAGS.
119append-flags() { 159append-flags() {
160 [[ -z $* ]] && return 0
120 export CFLAGS="${CFLAGS} $@" 161 export CFLAGS="${CFLAGS} $*"
121 export CXXFLAGS="${CXXFLAGS} $@" 162 export CXXFLAGS="${CXXFLAGS} $*"
122 [ "`is-flag -fno-stack-protector`" -o "`is-flag -fno-stack-protector-all`" ] && fstack-flags 163 export FFLAGS="${FFLAGS} $*"
164 export FCFLAGS="${FCFLAGS} $*"
123 return 0 165 return 0
124} 166}
125 167
168# @FUNCTION: replace-flags
169# @USAGE: <old> <new>
170# @DESCRIPTION:
171# Replace the <old> flag with <new>. Accepts shell globs for <old>.
126replace-flags() { 172replace-flags() {
127 # we do this fancy spacing stuff so as to not filter 173 [[ $# != 2 ]] \
128 # out part of a flag ... we want flag atoms ! :D 174 && echo && eerror "Usage: replace-flags <old flag> <new flag>" \
129 CFLAGS=" ${CFLAGS} " 175 && die "replace-flags takes 2 arguments, not $#"
130 CXXFLAGS=" ${CXXFLAGS} "
131 CFLAGS="${CFLAGS// ${1} / ${2} }"
132 CXXFLAGS="${CXXFLAGS// ${1} / ${2} }"
133 CFLAGS="${CFLAGS:1:${#CFLAGS}-2}"
134 CXXFLAGS="${CXXFLAGS:1:${#CXXFLAGS}-2}"
135 return 0
136}
137 176
177 local f fset
178 declare -a new_CFLAGS new_CXXFLAGS
179
180 for fset in CFLAGS CXXFLAGS FFLAGS FCFLAGS; do
181 # Looping over the flags instead of using a global
182 # substitution ensures that we're working with flag atoms.
183 # Otherwise globs like -O* have the potential to wipe out the
184 # list of flags.
185 for f in ${!fset}; do
186 # Note this should work with globs like -O*
187 [[ ${f} == ${1} ]] && f=${2}
188 eval new_${fset}\[\${\#new_${fset}\[@]}]=\${f}
189 done
190 eval export ${fset}=\${new_${fset}\[*]}
191 done
192
193 return 0
194}
195
196# @FUNCTION: replace-cpu-flags
197# @USAGE: <old> <new>
198# @DESCRIPTION:
199# Replace cpu flags (like -march/-mcpu/-mtune) that select the <old> cpu
200# with flags that select the <new> cpu. Accepts shell globs for <old>.
138replace-cpu-flags() { 201replace-cpu-flags() {
139 local newcpu="$1" ; shift 202 local newcpu="$#" ; newcpu="${!newcpu}"
140 local oldcpu="" 203 while [ $# -gt 1 ] ; do
141 for oldcpu in "$@" ; do 204 # quote to make sure that no globbing is done (particularly on
205 # ${oldcpu}) prior to calling replace-flags
142 replace-flags -march=${oldcpu} -march=${newcpu} 206 replace-flags "-march=${1}" "-march=${newcpu}"
143 replace-flags -mcpu=${oldcpu} -mcpu=${newcpu} 207 replace-flags "-mcpu=${1}" "-mcpu=${newcpu}"
144 replace-flags -mtune=${oldcpu} -mtune=${newcpu} 208 replace-flags "-mtune=${1}" "-mtune=${newcpu}"
209 shift
145 done 210 done
211 return 0
212}
213
214_is_flagq() {
215 local x
216 for x in ${!1} ; do
217 [[ ${x} == $2 ]] && return 0
218 done
146 return 0 219 return 1
147} 220}
148 221
222# @FUNCTION: is-flagq
223# @USAGE: <flag>
224# @DESCRIPTION:
225# Returns shell true if <flag> is in {C,CXX,F,FC}FLAGS, else returns shell false. Accepts shell globs.
226is-flagq() {
227 [[ -n $2 ]] && die "Usage: is-flag <flag>"
228 _is_flagq CFLAGS $1 || _is_flagq CXXFLAGS $1 || _is_flagq FFLAGS $1 || _is_flagq FCFLAGS $1
229}
230
231# @FUNCTION: is-flag
232# @USAGE: <flag>
233# @DESCRIPTION:
234# Echo's "true" if flag is set in {C,CXX,F,FC}FLAGS. Accepts shell globs.
149is-flag() { 235is-flag() {
150 for x in ${CFLAGS} ${CXXFLAGS} ; do 236 is-flagq "$@" && echo true
151 if [ "${x}" == "$1" ] ; then
152 echo true
153 return 0
154 fi
155 done
156 return 1
157} 237}
158 238
239# @FUNCTION: is-ldflagq
240# @USAGE: <flag>
241# @DESCRIPTION:
242# Returns shell true if <flag> is in LDFLAGS, else returns shell false. Accepts shell globs.
243is-ldflagq() {
244 [[ -n $2 ]] && die "Usage: is-ldflag <flag>"
245 _is_flagq LDFLAGS $1
246}
247
248# @FUNCTION: is-ldflag
249# @USAGE: <flag>
250# @DESCRIPTION:
251# Echo's "true" if flag is set in LDFLAGS. Accepts shell globs.
252is-ldflag() {
253 is-ldflagq "$@" && echo true
254}
255
256# @FUNCTION: filter-mfpmath
257# @USAGE: <math types>
258# @DESCRIPTION:
259# Remove specified math types from the fpmath flag. For example, if the user
260# has -mfpmath=sse,386, running `filter-mfpmath sse` will leave the user with
261# -mfpmath=386.
159filter-mfpmath() { 262filter-mfpmath() {
263 local orig_mfpmath new_math prune_math
264
160 # save the original -mfpmath flag 265 # save the original -mfpmath flag
161 local orig_mfpmath="`get-flag -mfpmath`" 266 orig_mfpmath=$(get-flag -mfpmath)
162 # get the value of the current -mfpmath flag 267 # get the value of the current -mfpmath flag
163 local new_math=" `get-flag mfpmath | tr , ' '` " 268 new_math=$(get-flag mfpmath)
269 new_math=" ${new_math//,/ } "
164 # figure out which math values are to be removed 270 # figure out which math values are to be removed
165 local prune_math="" 271 prune_math=""
166 for prune_math in "$@" ; do 272 for prune_math in "$@" ; do
167 new_math="${new_math/ ${prune_math} / }" 273 new_math=${new_math/ ${prune_math} / }
168 done 274 done
169 new_math="`echo ${new_math:1:${#new_math}-2} | tr ' ' ,`" 275 new_math=$(echo ${new_math})
276 new_math=${new_math// /,}
170 277
171 if [ -z "${new_math}" ] ; then 278 if [[ -z ${new_math} ]] ; then
172 # if we're removing all user specified math values are 279 # if we're removing all user specified math values are
173 # slated for removal, then we just filter the flag 280 # slated for removal, then we just filter the flag
174 filter-flags ${orig_mfpmath} 281 filter-flags ${orig_mfpmath}
175 else 282 else
176 # if we only want to filter some of the user specified 283 # if we only want to filter some of the user specified
178 replace-flags ${orig_mfpmath} -mfpmath=${new_math} 285 replace-flags ${orig_mfpmath} -mfpmath=${new_math}
179 fi 286 fi
180 return 0 287 return 0
181} 288}
182 289
290# @FUNCTION: strip-flags
291# @DESCRIPTION:
292# Strip C[XX]FLAGS of everything except known good/safe flags.
183strip-flags() { 293strip-flags() {
294 local x y flag NEW_CFLAGS NEW_CXXFLAGS NEW_FFLAGS NEW_FCFLAGS
295
184 setup-allowed-flags 296 setup-allowed-flags
185 297
186 local NEW_CFLAGS="" 298 local NEW_CFLAGS=""
187 local NEW_CXXFLAGS="" 299 local NEW_CXXFLAGS=""
300 local NEW_FFLAGS=""
301 local NEW_FCFLAGS=""
188 302
189 # Allow unstable C[XX]FLAGS if we are using unstable profile ... 303 # Allow unstable C[XX]FLAGS if we are using unstable profile ...
190 if has ~${ARCH} ${ACCEPT_KEYWORDS} ; then 304 if has ~$(tc-arch) ${ACCEPT_KEYWORDS} ; then
191 use debug && einfo "Enabling the use of some unstable flags"
192 ALLOWED_FLAGS="${ALLOWED_FLAGS} ${UNSTABLE_FLAGS}" 305 ALLOWED_FLAGS="${ALLOWED_FLAGS} ${UNSTABLE_FLAGS}"
193 fi 306 fi
194 307
195 set -f 308 set -f # disable pathname expansion
196 309
197 for x in ${CFLAGS} 310 for x in ${CFLAGS}; do
198 do
199 for y in ${ALLOWED_FLAGS} 311 for y in ${ALLOWED_FLAGS}; do
200 do
201 flag=${x%%=*} 312 flag=${x%%=*}
202 if [ "${flag%%${y}}" = "" ] 313 if [ "${flag%%${y}}" = "" ] ; then
203 then
204 NEW_CFLAGS="${NEW_CFLAGS} ${x}" 314 NEW_CFLAGS="${NEW_CFLAGS} ${x}"
205 break 315 break
206 fi 316 fi
207 done 317 done
208 done 318 done
209 319
210 for x in ${CXXFLAGS} 320 for x in ${CXXFLAGS}; do
211 do
212 for y in ${ALLOWED_FLAGS} 321 for y in ${ALLOWED_FLAGS}; do
213 do
214 flag=${x%%=*} 322 flag=${x%%=*}
215 if [ "${flag%%${y}}" = "" ] 323 if [ "${flag%%${y}}" = "" ] ; then
216 then
217 NEW_CXXFLAGS="${NEW_CXXFLAGS} ${x}" 324 NEW_CXXFLAGS="${NEW_CXXFLAGS} ${x}"
218 break 325 break
219 fi 326 fi
220 done 327 done
221 done 328 done
222 329
330 for x in ${FFLAGS}; do
331 for y in ${ALLOWED_FLAGS}; do
332 flag=${x%%=*}
333 if [ "${flag%%${y}}" = "" ] ; then
334 NEW_FFLAGS="${NEW_FFLAGS} ${x}"
335 break
336 fi
337 done
338 done
339
340 for x in ${FCFLAGS}; do
341 for y in ${ALLOWED_FLAGS}; do
342 flag=${x%%=*}
343 if [ "${flag%%${y}}" = "" ] ; then
344 NEW_FCFLAGS="${NEW_FCFLAGS} ${x}"
345 break
346 fi
347 done
348 done
349
223 # In case we filtered out all optimization flags fallback to -O2 350 # In case we filtered out all optimization flags fallback to -O2
224 if [ "${CFLAGS/-O}" != "${CFLAGS}" -a "${NEW_CFLAGS/-O}" = "${NEW_CFLAGS}" ]; then 351 if [ "${CFLAGS/-O}" != "${CFLAGS}" -a "${NEW_CFLAGS/-O}" = "${NEW_CFLAGS}" ]; then
225 NEW_CFLAGS="${NEW_CFLAGS} -O2" 352 NEW_CFLAGS="${NEW_CFLAGS} -O2"
226 fi 353 fi
227 if [ "${CXXFLAGS/-O}" != "${CXXFLAGS}" -a "${NEW_CXXFLAGS/-O}" = "${NEW_CXXFLAGS}" ]; then 354 if [ "${CXXFLAGS/-O}" != "${CXXFLAGS}" -a "${NEW_CXXFLAGS/-O}" = "${NEW_CXXFLAGS}" ]; then
228 NEW_CXXFLAGS="${NEW_CXXFLAGS} -O2" 355 NEW_CXXFLAGS="${NEW_CXXFLAGS} -O2"
229 fi 356 fi
357 if [ "${FFLAGS/-O}" != "${FFLAGS}" -a "${NEW_FFLAGS/-O}" = "${NEW_FFLAGS}" ]; then
358 NEW_FFLAGS="${NEW_FFLAGS} -O2"
359 fi
360 if [ "${FCFLAGS/-O}" != "${FCFLAGS}" -a "${NEW_FCFLAGS/-O}" = "${NEW_FCFLAGS}" ]; then
361 NEW_FCFLAGS="${NEW_FCFLAGS} -O2"
362 fi
230 363
231 set +f 364 set +f # re-enable pathname expansion
232
233 use debug \
234 && einfo "CFLAGS=\"${NEW_CFLAGS}\"" \
235 && einfo "CXXFLAGS=\"${NEW_CXXFLAGS}\""
236 365
237 export CFLAGS="${NEW_CFLAGS}" 366 export CFLAGS="${NEW_CFLAGS}"
238 export CXXFLAGS="${NEW_CXXFLAGS}" 367 export CXXFLAGS="${NEW_CXXFLAGS}"
368 export FFLAGS="${NEW_FFLAGS}"
369 export FCFLAGS="${NEW_FCFLAGS}"
370 return 0
371}
372
373test-flag-PROG() {
374 local comp=$1
375 local flags="$2"
376
377 [[ -z ${comp} || -z ${flags} ]] && \
239 return 0 378 return 1
240}
241 379
380 local PROG=$(tc-get${comp})
381 ${PROG} ${flags} -S -o /dev/null -xc /dev/null \
382 > /dev/null 2>&1
383}
384
385# @FUNCTION: test-flag-CC
386# @USAGE: <flag>
387# @DESCRIPTION:
388# Returns shell true if <flag> is supported by the C compiler, else returns shell false.
389test-flag-CC() { test-flag-PROG "CC" "$1"; }
390
391# @FUNCTION: test-flag-CXX
392# @USAGE: <flag>
393# @DESCRIPTION:
394# Returns shell true if <flag> is supported by the C++ compiler, else returns shell false.
395test-flag-CXX() { test-flag-PROG "CXX" "$1"; }
396
397# @FUNCTION: test-flag-F77
398# @USAGE: <flag>
399# @DESCRIPTION:
400# Returns shell true if <flag> is supported by the Fortran 77 compiler, else returns shell false.
401test-flag-F77() { test-flag-PROG "F77" "$1"; }
402
403# @FUNCTION: test-flag-FC
404# @USAGE: <flag>
405# @DESCRIPTION:
406# Returns shell true if <flag> is supported by the Fortran 90 compiler, else returns shell false.
407test-flag-FC() { test-flag-PROG "FC" "$1"; }
408
409test-flags-PROG() {
410 local comp=$1
411 local flags
412 local x
413
414 shift
415
416 [[ -z ${comp} ]] && return 1
417
418 x=""
419 for x in "$@" ; do
420 test-flag-${comp} "${x}" && flags="${flags}${flags:+ }${x}"
421 done
422
423 echo "${flags}"
424
425 # Just bail if we dont have any flags
426 [[ -n ${flags} ]]
427}
428
429# @FUNCTION: test-flags-CC
430# @USAGE: <flags>
431# @DESCRIPTION:
432# Returns shell true if <flags> are supported by the C compiler, else returns shell false.
433test-flags-CC() { test-flags-PROG "CC" "$@"; }
434
435# @FUNCTION: test-flags-CXX
436# @USAGE: <flags>
437# @DESCRIPTION:
438# Returns shell true if <flags> are supported by the C++ compiler, else returns shell false.
439test-flags-CXX() { test-flags-PROG "CXX" "$@"; }
440
441# @FUNCTION: test-flags-F77
442# @USAGE: <flags>
443# @DESCRIPTION:
444# Returns shell true if <flags> are supported by the Fortran 77 compiler, else returns shell false.
445test-flags-F77() { test-flags-PROG "F77" "$@"; }
446
447# @FUNCTION: test-flags-FC
448# @USAGE: <flags>
449# @DESCRIPTION:
450# Returns shell true if <flags> are supported by the Fortran 90 compiler, else returns shell false.
451test-flags-FC() { test-flags-PROG "FC" "$@"; }
452
453# @FUNCTION: test-flags
454# @USAGE: <flags>
455# @DESCRIPTION:
456# Short-hand that should hopefully work for both C and C++ compiler, but
457# its really only present due to the append-flags() abomination.
458test-flags() { test-flags-CC "$@"; }
459
460# @FUNCTION: test_flag
461# @DESCRIPTION:
462# DEPRICIATED, use test-flags()
242test_flag() { 463test_flag() {
243 if [ -z "`gcc -S -xc "$@" -o /dev/null /dev/null 2>&1`" ]; then 464 ewarn "test_flag: deprecated, please use test-flags()!" >&2
244 echo "$@" 465
466 test-flags-CC "$@"
467}
468
469# @FUNCTION: test_version_info
470# @USAGE: <version>
471# @DESCRIPTION:
472# Returns shell true if the current C compiler version matches <version>, else returns shell false.
473# Accepts shell globs.
474test_version_info() {
475 if [[ $($(tc-getCC) --version 2>&1) == *$1* ]]; then
245 return 0 476 return 0
246 fi 477 else
247 return 1 478 return 1
479 fi
248} 480}
249 481
482# @FUNCTION: strip-unsupported-flags
483# @DESCRIPTION:
484# Strip {C,CXX,F,FC}FLAGS of any flags not supported by the active toolchain.
250strip-unsupported-flags() { 485strip-unsupported-flags() {
251 for x in ${CFLAGS} ; do 486 export CFLAGS=$(test-flags-CC ${CFLAGS})
252 NEW_CFLAGS=${NEW_CFLAGS}" ""`test_flag ${x}`" 487 export CXXFLAGS=$(test-flags-CXX ${CXXFLAGS})
253 done 488 export FFLAGS=$(test-flags-F77 ${FFLAGS})
254 for x in ${CXXFLAGS} ; do 489 export FCFLAGS=$(test-flags-FC ${FCFLAGS})
255 NEW_CXXFLAGS=${NEW_CXXFLAGS}" ""`test_flag ${x}`"
256 done
257
258 export CFLAGS="${NEW_CFLAGS}"
259 export CXXFLAGS="${NEW_CXXFLAGS}"
260} 490}
261 491
492# @FUNCTION: get-flag
493# @USAGE: <flag>
494# @DESCRIPTION:
495# Find and echo the value for a particular flag. Accepts shell globs.
262get-flag() { 496get-flag() {
497 local f findflag="$1"
498
263 # this code looks a little flaky but seems to work for 499 # this code looks a little flaky but seems to work for
264 # everything we want ... 500 # everything we want ...
265 # for example, if CFLAGS="-march=i686": 501 # for example, if CFLAGS="-march=i686":
266 # `get-flags -march` == "-march=i686" 502 # `get-flag -march` == "-march=i686"
267 # `get-flags march` == "i686" 503 # `get-flag march` == "i686"
268 local findflag="$1"
269 for f in ${CFLAGS} ${CXXFLAGS} ; do 504 for f in ${CFLAGS} ${CXXFLAGS} ${FFLAGS} ${FCFLAGS} ; do
270 if [ "${f/${findflag}}" != "${f}" ] ; then 505 if [ "${f/${findflag}}" != "${f}" ] ; then
271 echo "${f/-${findflag}=}" 506 printf "%s\n" "${f/-${findflag}=}"
272 return 0 507 return 0
273 fi 508 fi
274 done 509 done
275 return 1 510 return 1
276} 511}
277 512
513# @FUNCTION: has_hardened
514# @DESCRIPTION:
515# DEPRECATED - use gcc-specs-relro or gcc-specs-now from toolchain-funcs
278has_hardened() { 516has_hardened() {
279 local cc=${CC:-gcc} 517 ewarn "has_hardened: deprecated, please use gcc-specs-{relro,now}()!" >&2
280 [[ $(${cc%% *} --version 2>&1) == *Hardened* ]]
281 return $?
282}
283 518
519 test_version_info Hardened && return 0
520 # The specs file wont exist unless gcc has GCC_SPECS support
521 [[ -f ${GCC_SPECS} && ${GCC_SPECS} != ${GCC_SPECS/hardened/} ]]
522}
523
524# @FUNCTION: has_pic
525# @DESCRIPTION:
526# DEPRECATED - use gcc-specs-pie from toolchain-funcs
527# indicate whether PIC is set
284has_pic() { 528has_pic() {
285 [ "${CFLAGS/-fPIC}" != "${CFLAGS}" ] && return 0 529 ewarn "has_pic: deprecated, please use gcc-specs-pie()!" >&2
286 [ "${CFLAGS/-fpic}" != "${CFLAGS}" ] && return 0 530
287 [ ! -z "`${CC/ .*/} --version| grep pie`" ] && return 0 531 [[ ${CFLAGS/-fPIC} != ${CFLAGS} || \
532 ${CFLAGS/-fpic} != ${CFLAGS} ]] || \
533 gcc-specs-pie
534}
535
536# @FUNCTION: has_pie
537# @DESCRIPTION:
538# DEPRECATED - use gcc-specs-pie from toolchain-funcs
539# indicate whether PIE is set
540has_pie() {
541 ewarn "has_pie: deprecated, please use gcc-specs-pie()!" >&2
542
543 [[ ${CFLAGS/-fPIE} != ${CFLAGS} || \
544 ${CFLAGS/-fpie} != ${CFLAGS} ]] || \
545 gcc-specs-pie
546}
547
548# @FUNCTION: has_ssp_all
549# @DESCRIPTION:
550# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
551# indicate whether code for SSP is being generated for all functions
552has_ssp_all() {
553 ewarn "has_ssp_all: deprecated, please use gcc-specs-ssp()!" >&2
554
555 # note; this matches only -fstack-protector-all
556 [[ ${CFLAGS/-fstack-protector-all} != ${CFLAGS} || \
557 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP_ALL__) ]] || \
558 gcc-specs-ssp-all
559}
560
561# @FUNCTION: has_ssp
562# @DESCRIPTION:
563# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
564# indicate whether code for SSP is being generated
565has_ssp() {
566 ewarn "has_ssp: deprecated, please use gcc-specs-ssp()!" >&2
567
568 # note; this matches both -fstack-protector and -fstack-protector-all
569 [[ ${CFLAGS/-fstack-protector} != ${CFLAGS} || \
570 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP__) ]] || \
571 gcc-specs-ssp
572}
573
574# @FUNCTION: has_m64
575# @DESCRIPTION:
576# This doesn't test if the flag is accepted, it tests if the flag actually
577# WORKS. Non-multilib gcc will take both -m32 and -m64. If the flag works
578# return code is 0, else the return code is 1.
579has_m64() {
580 # this doesnt test if the flag is accepted, it tests if the flag
581 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
582 # please dont replace this function with test_flag in some future
583 # clean-up!
584
585 local temp="$(emktemp)"
586 echo "int main() { return(0); }" > "${temp}".c
587 MY_CC=$(tc-getCC)
588 ${MY_CC/ .*/} -m64 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
589 local ret=$?
590 rm -f "${temp}".c
591 [[ ${ret} != 1 ]] && return 0
288 return 1 592 return 1
289} 593}
290 594
291has_pie() { 595# @FUNCTION: has_m32
292 [ "${CFLAGS/-fPIE}" != "${CFLAGS}" ] && return 0 596# @DESCRIPTION:
293 [ "${CFLAGS/-fpie}" != "${CFLAGS}" ] && return 0 597# This doesn't test if the flag is accepted, it tests if the flag actually
294 [ ! -z "`${CC/ .*/} --version| grep pie`" ] && return 0 598# WORKS. Non-mulilib gcc will take both -m32 and -64. If the flag works return
599# code is 0, else return code is 1.
600has_m32() {
601 # this doesnt test if the flag is accepted, it tests if the flag
602 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
603 # please dont replace this function with test_flag in some future
604 # clean-up!
605
606 [ "$(tc-arch)" = "amd64" ] && has_multilib_profile && return 0
607
608 local temp=$(emktemp)
609 echo "int main() { return(0); }" > "${temp}".c
610 MY_CC=$(tc-getCC)
611 ${MY_CC/ .*/} -m32 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
612 local ret=$?
613 rm -f "${temp}".c
614 [[ ${ret} != 1 ]] && return 0
295 return 1 615 return 1
296} 616}
297
298has_ssp() {
299 [ "${CFLAGS/-fstack-protector}" != "${CFLAGS}" ] && return 0
300 [ ! -z "`${CC/ .*/} --version| grep ssp`" ] && return 0
301 return 1
302}
303 617
618# @FUNCTION: replace-sparc64-flags
619# @DESCRIPTION:
620# Sets mcpu to v8 and uses the original value as mtune if none specified.
304replace-sparc64-flags() { 621replace-sparc64-flags() {
305 local SPARC64_CPUS="ultrasparc v9" 622 local SPARC64_CPUS="ultrasparc3 ultrasparc v9"
306 623
307 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ] 624 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ]; then
308 then
309 for x in ${SPARC64_CPUS} 625 for x in ${SPARC64_CPUS}; do
310 do
311 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}" 626 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}"
312 done 627 done
313 else 628 else
314 for x in ${SPARC64_CPUS} 629 for x in ${SPARC64_CPUS}; do
315 do
316 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}" 630 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
317 done 631 done
318 fi 632 fi
319 633
320 if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ] 634 if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ]; then
321 then
322 for x in ${SPARC64_CPUS} 635 for x in ${SPARC64_CPUS}; do
323 do
324 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}" 636 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}"
325 done 637 done
326 else 638 else
327 for x in ${SPARC64_CPUS} 639 for x in ${SPARC64_CPUS}; do
328 do
329 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}" 640 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
330 done 641 done
331 fi 642 fi
332}
333 643
644 export CFLAGS CXXFLAGS
645}
646
647# @FUNCTION: append-ldflags
648# @USAGE: <flags>
649# @DESCRIPTION:
650# Add extra <flags> to the current LDFLAGS.
334append-ldflags() { 651append-ldflags() {
652 [[ -z $* ]] && return 0
653 local flag
654 for flag in "$@"; do
655 [[ ${flag} == -l* ]] && \
656 ewarn "Appending a library link instruction (${flag}); libraries to link to should not be passed through LDFLAGS"
657 done
658
335 LDFLAGS="${LDFLAGS} $@" 659 export LDFLAGS="${LDFLAGS} $*"
336 return 0 660 return 0
337} 661}
338 662
663# @FUNCTION: filter-ldflags
664# @USAGE: <flags>
665# @DESCRIPTION:
666# Remove particular <flags> from LDFLAGS. Accepts shell globs.
339filter-ldflags() { 667filter-ldflags() {
340 # we do this fancy spacing stuff so as to not filter 668 _filter-var LDFLAGS "$@"
341 # out part of a flag ... we want flag atoms ! :D 669 return 0
342 LDFLAGS=" ${LDFLAGS} " 670}
671
672# @FUNCTION: raw-ldflags
673# @USAGE: <flags>
674# @DESCRIPTION:
675# Turn C style ldflags (-Wl,-foo) into straight ldflags - the results
676# are suitable for passing directly to 'ld'; note LDFLAGS is usually passed
677# to gcc where it needs the '-Wl,'.
678raw-ldflags() {
679 local x input="$@"
680 [[ -z ${input} ]] && input=${LDFLAGS}
681 set --
343 for x in "$@" ; do 682 for x in ${input} ; do
344 LDFLAGS="${LDFLAGS// ${x} / }" 683 x=${x#-Wl,}
684 set -- "$@" ${x//,/ }
345 done 685 done
346 LDFLAGS="${LDFLAGS:1:${#LDFLAGS}-2}" 686 echo "$@"
347 return 0
348} 687}
349 688
350etexec-flags() { 689# @FUNCTION: bindnow-flags
351 # if your not using a hardened compiler you wont need this 690# @RETURN: Returns the flags to enable "now" binding in the current selected linker.
352 # PIC/no-pic kludge in the first place. 691# @DESCRIPTION:
353 has_hardened || return 692# DEPRECATED - Gets the flags needed for "NOW" binding
693bindnow-flags() {
694 ewarn "QA: stop using the bindnow-flags function ... simply drop it from your ebuild" >&2
354 695
355 has_pie || has_pic 696 case $($(tc-getLD) -v 2>&1 </dev/null) in
356 if [ $? == 0 ] ; then 697 *GNU* | *'with BFD'*) # GNU ld
357 [ -z "`is-flag -fno-pic`" ] && 698 echo "-Wl,-z,now" ;;
358 export CFLAGS="${CFLAGS} `test_flag -fno-pic`" 699 *Apple*) # Darwin ld
359 700 echo "-bind_at_load" ;;
360 [ -z "`is-flag -nopie`" ] && 701 *)
361 export CFLAGS="${CFLAGS} `test_flag -nopie`" 702 # Some linkers just recognize -V instead of -v
362 fi 703 case $($(tc-getLD) -V 2>&1 </dev/null) in
704 *Solaris*) # Solaris accept almost the same GNU options
705 echo "-Wl,-z,now" ;;
706 esac
707 ;;
708 esac
363} 709}
364 710
365fstack-flags() { 711
366 has_ssp 712# Some tests for when we screw with things and want to make
367 if [ $? == 0 ] ; then 713# sure we didn't break anything
368 [ -z "`is-flag -fno-stack-protector`" ] && 714#TESTS() {
369 export CFLAGS="${CFLAGS} `test_flag -fno-stack-protector`" 715# CFLAGS="-a -b -c=1"
370 fi 716# CXXFLAGS="-x -y -z=2"
371} 717# LDFLAGS="-l -m -n=3"
718#
719# die() { exit 1; }
720# (is-flag 1 2 3) && die
721# (is-ldflag 1 2 3) && die
722#
723# is-flagq -l && die
724# is-ldflagq -a && die
725# is-flagq -a || die
726# is-flagq -x || die
727# is-ldflagq -n=* || die
728# is-ldflagq -n && die
729#
730# strip-unsupported-flags
731# [[ ${CFLAGS} == "-c=1" ]] || die
732# [[ ${CXXFLAGS} == "-y -z=2" ]] || die
733#
734# echo "All tests pass"
735#}
736#TESTS

Legend:
Removed from v.1.54  
changed lines
  Added in v.1.124

  ViewVC Help
Powered by ViewVC 1.1.20